=== src/pybind/mgr/diskprediction_local/requirements.txt ===
numpy==1.15.1
scipy==1.1.0
scikit-learn==0.19.2
