=== debian/changelog ===
ceph (18.2.4+ds-7deepin1) unstable; urgency=medium

  * fix fmt error, add ceph-18.2.0-fmt10-fixes.patch.

 -- LiChengGang <lichenggang@uniontech.com>  Thu, 10 Oct 2024 10:27:58 +0800

ceph (18.2.4+ds-7) unstable; urgency=medium

  * Removing superfluous dependency on python3-six in ceph-mgr-rook
    (Closes: #1079864).

 -- Daniel Baumann <mail@daniel-baumann.ch>  Wed, 18 Sep 2024 09:47:35 +0200

ceph (18.2.4+ds-6) unstable; urgency=medium

  * Removing manually specifing zero jvm on mips64el as it doesn't work
    and we better wait for the proper fix in cmake itself (#1078712).
  * Building with fixed cmake (Closes: #1078446).
  * Trimming unused entry in last changelog.

 -- Daniel Baumann <daniel@debian.org>  Thu, 15 Aug 2024 12:53:10 +0200

ceph (18.2.4+ds-5) unstable; urgency=medium

  * Updating libcephfs2.symbols.
  * Using fuse3 instead of fuse.
  * Trying to fix FTBFS on mips64el (#1078446) since openjdk-21 became
    default-jdk by manually specifing the zero jvm as there's no hotspot
    jvm anymore on this architecture.

 -- Daniel Baumann <daniel@debian.org>  Wed, 14 Aug 2024 18:45:20 +0200

ceph (18.2.4+ds-4) unstable; urgency=medium

  * Correcting execution order of dh_movetousr, thanks to Helmut Grohne
    <helmut@subdivi.de> (Closes: #1073640).
  * Updating update-java-source-target-flags.patch for openjdk 21.
  * Correcting accidentally wrong email address in previous changelog
    entry.

 -- Daniel Baumann <daniel@debian.org>  Thu, 08 Aug 2024 17:01:36 +0200

ceph (18.2.4+ds-3) unstable; urgency=medium

  * Renumbering patches sequentially.
  * Removing unused do-not-include-mgr_legacy_options.h.patch.
  * Rediffing and harmonizing enable-strsignal.patch.
  * Rediffing and harmonizing update-java-source-target-flags.patch.
  * Rediffing and harmonizing disable-crypto.patch.
  * Adding patch to avoid cephadm writing its own logrotate configuration
    (Closes: #1041092).
  * Adding patch from Dandan Zhang <zhangdandan@loongson.cn> to fix FTBFS
    on loong64 (Closes: #1055047, #1069022).
  * Trimming whitespaces in debian changelog.
  * Wrap-and-sorting debian packaging files.

 -- Daniel Baumann <daniel@debian.org>  Sat, 27 Jul 2024 07:25:47 +0200

ceph (18.2.4+ds-2) unstable; urgency=medium

  * Removing unneeded depends in ceph-mds for shorter dependency chains.
  * Removing unneeded depends in ceph-mgr for shorter dependency chains.
  * Removing unneeded depends in ceph-mon for shorter dependency chains.
  * Moving systemd units to /usr (Closes: #1073640)
  * Adding udev rules for rbd to activate LUKS volumes, thanks to Daniel
    Schreiber <daniel.schreiber@hrz.tu-chemnitz.de> (Closes: #1064970).

 -- Daniel Baumann <daniel@debian.org>  Fri, 26 Jul 2024 14:15:31 +0200

ceph (18.2.4+ds-1) unstable; urgency=medium

  [ Thomas Goirand ]
  * Add Daniel as uploader. Remove Gaudenz (not active anymore).

  [ Daniel Baumann ]
  * Merging upstream version 18.2.4+ds.
  * Cherry-picking patches from upstream to fix FTBFS with gcc-14 (Closes:
    #1074874).

 -- Daniel Baumann <daniel@debian.org>  Fri, 26 Jul 2024 07:00:05 +0200

ceph (18.2.3+ds-3) unstable; urgency=medium

  * mips64el: Use -mxgot on CFLAGS, not LDFLAGS, thanks to Adrian Bunk for the
    tip.

 -- Thomas Goirand <zigo@debian.org>  Sun, 26 May 2024 11:07:21 +0200

ceph (18.2.3+ds-2) unstable; urgency=medium

  * Up the max number of build processes on computers with more than 48 GB.
  * Add "export DEB_LDFLAGS_MAINT_APPEND= -mxgot" for mips64el to avoid FTBFS.

 -- Thomas Goirand <zigo@debian.org>  Fri, 24 May 2024 21:23:32 +0200

ceph (18.2.3+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add fix-ftbfs-with-newer-snappy.patch (Closes: #1071300).
  * Fix d/copyright syntax.
  * Fix some scripts flags (they were not executable).
  * debian/repack: fix deleting files from upstream.
  * Rebase, refresh, drop applied upstream, rework patches:
    - pybind-rbd-make-cdef-functions-not-propagate-excepti.patch: drop.
    - remove-usage-of-distutils.patch drop cephfs-shell part.
    - 0001-cmake-promote-uring-package-search-to-top-level.patch partially
      dropped (partially applied upstream).
    - 0001-cmake-populate-liburing-include-and-library-paths-do.patch refresh.
    - 0001-cmake-promote-uring-package-search-to-top-level.patch refresh.
    - 0001-cmake-rocksdb-make-sure-dependencies-build-before-ro.patch refresh.
    - 32bit-fixes.patch refresh.
    - enable-strsignal.patch refresh.

 -- Thomas Goirand <zigo@debian.org>  Wed, 22 May 2024 08:12:10 +0200

ceph (18.2.1+ds-9) unstable; urgency=medium

  * Do not chmod +x ceph-osd-prestart.sh if we're building arch:all.

 -- Thomas Goirand <zigo@debian.org>  Fri, 26 Apr 2024 09:00:30 +0200

ceph (18.2.1+ds-8) unstable; urgency=medium

  * Add missing depends: libsqlite3-mod-ceph for ceph-mgr.
  * Fix executable rights of /usr/lib/ceph/ceph-osd-prestart.sh that was
    preventing osd to start.
  * Fix prefix of path of ceph-osd-prestart.sh.

 -- Thomas Goirand <zigo@debian.org>  Thu, 25 Apr 2024 14:48:30 +0200

ceph (18.2.1+ds-7) unstable; urgency=medium

  * Add fix-for-cmake-3.29.2.patch.

 -- Thomas Goirand <zigo@debian.org>  Thu, 25 Apr 2024 08:57:27 +0200

ceph (18.2.1+ds-6) unstable; urgency=medium

  * Add patch to fix removal of python3-distutils.

 -- Thomas Goirand <zigo@debian.org>  Wed, 24 Apr 2024 14:24:31 +0200

ceph (18.2.1+ds-5) unstable; urgency=medium

  * Removed python3-distutils from depends (Closes: #1065838).
  * Refreshed 0001-cmake-promote-uring-package-search-to-top-level.patch.

 -- Thomas Goirand <zigo@debian.org>  Sun, 10 Mar 2024 15:52:49 +0100

ceph (18.2.1+ds-4) unstable; urgency=medium

  * Re-enable system's liburing as it doesn't fix anything, and instead,
    use dh_auto_build --buildsystem=cmake -- legacy-option-headers before
    building to avoid a race condition where build happens before generating
    headers.

 -- Thomas Goirand <zigo@debian.org>  Fri, 08 Mar 2024 13:21:05 +0100


