=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Maintainer: Ceph Packaging Team <team+ceph@tracker.debian.org>
Uploaders:
 James Page <jamespage@debian.org>,
 Daniel Baumann <daniel@debian.org>,
 Bernd Zeimetz <bzed@debian.org>,
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 architecture-is-64-bit,
 cmake (>= 3.30.2-2~),
 cython3,
 debhelper-compat (= 11),
 default-jdk,
 dh-exec,
 dh-python,
 dpkg-dev (>= 1.16.1~),
 flex,
 gperf,
 javahelper,
 junit4,
 libaio-dev,
 libbabeltrace-ctf-dev,
 libbabeltrace-dev,
 libblkid-dev (>= 2.17),
 libboost-atomic-dev,
 libboost-chrono-dev (>= 1.81.0~),
 libboost-context-dev (>= 1.81.0~),
 libboost-coroutine-dev (>= 1.81.0~),
 libboost-date-time-dev (>= 1.81.0~),
 libboost-filesystem-dev (>= 1.81.0~),
 libboost-iostreams-dev (>= 1.81.0~),
 libboost-program-options-dev (>= 1.81.0~),
 libboost-python-dev (>= 1.81.0~),
 libboost-random-dev (>= 1.81.0~),
 libboost-regex-dev (>= 1.81.0~),
 libboost-system-dev (>= 1.81.0~),
 libboost-test-dev (>= 1.81.0~),
 libboost-thread-dev (>= 1.81.0~),
 libboost-timer-dev (>= 1.81.0~),
 libbz2-dev,
 libc-ares-dev,
 libcap-dev,
 libcap-ng-dev,
 libcrypto++-dev,
 libcryptsetup-dev,
 libcunit1-dev,
 libcurl4-gnutls-dev,
 libdaxctl-dev,
 libedit-dev,
 libevent-dev,
 libexpat1-dev,
 libfmt-dev,
 libfuse3-dev,
 libgf-complete-dev,
 libgnutls28-dev,
 libgoogle-perftools-dev [amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64 ppc64el riscv64 powerpc s390x],
 libhwloc-dev,
 libibverbs-dev,
 libicu-dev,
 libjerasure-dev,
 libkeyutils-dev,
 libldap2-dev,
 liblua5.3-dev,
 liblz4-dev (>= 0.0~r131),
 libncurses-dev,
 libndctl-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libnss3-dev,
 libnuma-dev,
 liboath-dev,
 libpciaccess-dev,
 libpmem-dev [amd64 arm64 ppc64el riscv64],
 libpmemobj-dev [amd64 arm64 ppc64el riscv64],
 libprotobuf-dev,
 librabbitmq-dev,
 librdmacm-dev,
 libre2-dev,
 libsctp-dev,
 libsnappy-dev,
 libsqlite3-dev,
 libssl-dev,
 libthrift-dev,
 libtool,
 libudev-dev,
 liburing-dev,
 libutf8proc-dev,
 libxml2-dev,
 libyaml-cpp-dev,
 libzstd-dev,
 lsb-release,
 nasm [amd64],
 ninja-build,
 nlohmann-json3-dev,
 parted,
 pkg-config,
 protobuf-compiler,
 python3-bcrypt,
 python3-cherrypy3,
 python3-coverage,
 python3-dateutil,
 python3-dev,
 python3-jwt,
 python3-natsort,
 python3-openssl,
 python3-packaging,
 python3-pecan,
 python3-prettytable,
 python3-requests,
 python3-scipy,
 python3-setuptools,
 python3-sphinx,
 python3-werkzeug,
 python3-yaml,
 ragel,
 systemd,
 systemtap-sdt-dev,
 tox,
 uuid-runtime,
 valgrind [amd64 armhf arm64 i386 mips64el mipsel ppc64 ppc64el s390x],
 virtualenv,
 xfslibs-dev,
 xmlstarlet,
 zlib1g-dev,
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/ceph-team/ceph.git
Vcs-Browser: https://salsa.debian.org/ceph-team/ceph
Homepage: http://ceph.com/

Package: ceph
Architecture: linux-any
Depends:
 ceph-mgr (= ${binary:Version}),
 ceph-mon (= ${binary:Version}),
 ceph-osd (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: linux-any
Depends:
 binutils,
 ceph-common (= ${binary:Version}),
 cryptsetup-bin | cryptsetup,
 e2fsprogs,
 gdisk,
 hdparm | sdparm,
 logrotate,
 nvme-cli,
 parted,
 psmisc,
 smartmontools,
 uuid-runtime,
 xfsprogs,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Recommends:
 btrfs-tools,
 ceph-mds (= ${binary:Version}),
 chrony | time-daemon | ntp,
 librados2 (= ${binary:Version}),
 libradosstriper1 (= ${binary:Version}),
 librbd1 (= ${binary:Version}),
Description: common ceph daemon libraries and management tools
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-base-dbg
Architecture: linux-any
Section: debug
Depends:
 ceph-base (= ${binary:Version}),
 ${misc:Depends},
Description: debugging symbols for ceph-base
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the debugging symbols for ceph-base.

Package: ceph-common
Architecture: linux-any
Depends:
 adduser,
 librbd1 (= ${binary:Version}),
 python3-ceph-argparse (= ${binary:Version}),
 python3-ceph-common (<< ${source:Version}.1~),
 python3-ceph-common (>= ${source:Version}),
 python3-cephfs (= ${binary:Version}),
 python3-prettytable,
 python3-rados (= ${binary:Version}),
 python3-rbd (= ${binary:Version}),
 python3-requests,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Breaks:
 radosgw (<< 18),
Replaces:
 radosgw (<< 18),
Conflicts:
 ceph-client-tools,
Suggests:
 ceph,
 ceph-mds,
Description: common utilities to mount and interact with a ceph storage cluster
 Ceph is a distributed storage and file system designed to provide
 excellent performance, reliability, and scalability. This is a collection
 of common tools that allow one to interact with and administer a Ceph cluster.

Package: ceph-common-dbg
Architecture: linux-any
Section: debug
Depends:
 ceph-common (= ${binary:Version}),
 ${misc:Depends},
Description: debugging symbols for ceph-common
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the debugging symbols for ceph-common.

Package: ceph-fuse
Architecture: amd64
Depends:
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 fuse3,
Description: FUSE-based client for the Ceph distributed file system
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 FUSE-based client that allows one to mount a Ceph file system without
 root privileges.
 .
 Because the FUSE-based client has certain inherent performance
 limitations, it is recommended that the native Linux kernel client
 be used if possible.  If it is not practical to load a kernel module
 (insufficient privileges, older kernel, etc.), then the FUSE client will
 do.

Package: ceph-fuse-dbg
Architecture: amd64
Depends:
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 fuse3,
Description: FUSE-based client for the Ceph distributed file system - debug
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 FUSE-based client that allows one to mount a Ceph file system without
 root privileges.
 .
 Because the FUSE-based client has certain inherent performance
 limitations, it is recommended that the native Linux kernel client
 be used if possible.  If it is not practical to load a kernel module
 (insufficient privileges, older kernel, etc.), then the FUSE client will
 do.
 .
 This package contains the debug symbols for ceph-fuse.

Package: ceph-grafana-dashboards
Architecture: all
Depends:
 ${misc:Depends},
Description: grafana dashboards for the ceph dashboard
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains Grafana dashboards that are used by the Ceph Dashboard
 for monitoring.

Package: ceph-immutable-object-cache
Architecture: linux-any
Depends:
 ceph-common (= ${binary:Version}),
 librados2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ceph daemon for immutable object cache
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.  This is a daemon for immutable
 object cache.

Package: ceph-immutable-object-cache-dbg
Architecture: linux-any
Section: debug
Depends:
 ceph-immutable-object-cache (= ${binary:Version}),
 ${misc:Depends},
Description: debugging symbols for ceph-immutable-object-cache
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.  This is a daemon for immutable
 object cache.
 .
 This package contains the debugging symbols for ceph-immutable-object-cache.

Package: ceph-mds
Architecture: linux-any
Depends:
 ceph-common (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ceph-common,
 ceph-fuse,
 libcephfs2,
Description: metadata server for the ceph distributed file system
 Ceph is a distributed storage and network file system designed to
 provide excellent performance, reliability, and scalability.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mds-dbg
Architecture: linux-any
Section: debug
Depends:
 ceph-mds (= ${binary:Version}),
 ${misc:Depends},
Description: debugging symbols for ceph-mds
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the debugging symbols for ceph-mds.

Package: ceph-mgr
Architecture: linux-any
Depends:
 ceph-common (= ${binary:Version}),
 ceph-mgr-modules-core (<< ${source:Version}.1~),
 ceph-mgr-modules-core (>= ${source:Version}),
 libsqlite3-mod-ceph (<< ${source:Version}.1~),
 libsqlite3-mod-ceph (>= ${source:Version}),
 python3-bcrypt,
 python3-ceph-argparse (= ${binary:Version}),
 python3-cephfs (= ${binary:Version}),
 python3-cherrypy3,
 python3-jwt,
 python3-openssl,
 python3-pecan,
 python3-requests,
 python3-werkzeug,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 ceph-mgr-dashboard,
 ceph-mgr-diskprediction-local,
 ceph-mgr-rook,
Description: manager for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mgr-cephadm
Architecture: all
Depends:
 ceph-mgr (<< ${source:Version}.1~),
 ceph-mgr (>= ${source:Version}),
 cephadm,
 openssh-client,
 python3-asyncssh,
 python3-cherrypy3,
 python3-cryptography,
 python3-jinja2,
 ${misc:Depends},
 ${python3:Depends},
Description: cephadm orchestrator module for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the CEPHADM module for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to perform orchestration functions
 over a standard SSH connection.

Package: ceph-mgr-dashboard
Architecture: all
Depends:
 ceph-common (<< ${binary:Version}.1~),
 ceph-common (>= ${binary:Version}),
 ceph-mgr (<< ${binary:Version}.1~),
 ceph-mgr (>= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-jwt,
 python3-more-itertools,
 python3-openssl,
 python3-pkg-resources,
 python3-prettytable,
 python3-requests,
 python3-routes,
 python3-werkzeug,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: dashboard plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package provides a ceph-mgr plugin, providing a web-based
 application to monitor and manage many aspects of a Ceph cluster and
 related components.
 .
 See the Dashboard documentation at http://docs.ceph.com/ for details
